/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20140214-64 [Mar 29 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembly of ssdt2.dat, Sun Jun 29 12:08:15 2014
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000001B3 (435)
 *     Revision         0x01
 *     Checksum         0xD8
 *     OEM ID           "Intel"
 *     OEM Table ID     "zpodd"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20091112 (537465106)
 */
DefinitionBlock ("ssdt2.aml", "SSDT", 1, "Intel", "zpodd", 0x00001000)
{
    /*
     * iASL Warning: There were 1 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     */
    External (P8XH, MethodObj)    // Warning: Unresolved Method, guessing 2 arguments (may be incorrect, see warning above)

    External (_SB_.PCI0.SAT0)
    External (_SB_.PCI0.SAT0.PRT0, DeviceObj)
    External (FDTP)
    External (GIV0)
    External (GL00)
    External (GPE3)
    External (GPS3)
    External (PFLV)
    External (RTD3)

    If (LEqual (RTD3, Zero))
    {
        Name (SCEN, One)
        Scope (\_SB.PCI0.SAT0.PRT0)
        {
            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If (LEqual (Arg0, Buffer (0x10)
                        {
                            /* 0000 */   0x30, 0xEF, 0xFA, 0xBD, 0xBB, 0xAE, 0xDE, 0x11,
                            /* 0008 */   0x8A, 0x39, 0x08, 0x00, 0x20, 0x0C, 0x9A, 0x66
                        }))
                {
                    While (One)
                    {
                        Store (ToInteger (Arg2), _T_0)
                        If (LEqual (_T_0, Zero))
                        {
                            While (One)
                            {
                                Store (ToInteger (Arg1), _T_1)
                                If (LEqual (_T_1, One))
                                {
                                    If (LEqual (PFLV, FDTP))
                                    {
                                        Return (Buffer (One)
                                        {
                                             0x00
                                        })
                                    }

                                    Return (Buffer (One)
                                    {
                                         0x0F
                                    })
                                }
                                Else
                                {
                                    Return (Buffer (One)
                                    {
                                         0x00
                                    })
                                }

                                Break
                            }
                        }
                        Else
                        {
                            If (LEqual (_T_0, One))
                            {
                                Return (One)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x02))
                                {
                                    P8XH (Zero, 0xDF)
                                    Store (Zero, GPE3)
                                    If (LEqual (And (\GL00, 0x08), 0x08))
                                    {
                                        Or (\GIV0, 0x08, \GIV0)
                                    }
                                    Else
                                    {
                                        And (\GIV0, 0xF7, \GIV0)
                                    }

                                    Store (Zero, SCEN)
                                    Or (\GL00, 0x10, \GL00)
                                    Sleep (0xC8)
                                    Store (One, GPS3)
                                    Store (One, GPE3)
                                    Store (One, SCEN)
                                    Return (One)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x03))
                                    {
                                        P8XH (Zero, 0xD0)
                                        Store (Zero, GPE3)
                                        Store (One, GPS3)
                                        And (\GL00, 0xEF, \GL00)
                                        Return (One)
                                    }
                                    Else
                                    {
                                        Return (Zero)
                                    }
                                }
                            }
                        }

                        Break
                    }
                }
                Else
                {
                    Return (Zero)
                }
            }
        }

        Scope (\_GPE)
        {
            Method (_L13, 0, NotSerialized)  // _Lxx: Level-Triggered GPE
            {
                P8XH (Zero, 0xDA)
                If (LEqual (SCEN, Zero))
                {
                    Return (Zero)
                }

                Store (Zero, GPE3)
                And (\GL00, 0xEF, \GL00)
                Notify (\_SB.PCI0.SAT0, 0x80)
                Return (Zero)
            }
        }
    }
}

